--=======================================================================================================================
-- RIVER CONNECTION TRAIT FIX
--=======================================================================================================================
include("RiverConnections.lua")
-------------------------------------------------------------------------------------------------------------------------
local gRiverManager = nil
local gNeedRescan = false

function getRiverManager(iPlayer)
	if (gRiverManager == nil) then
		gRiverManager = RiverManager:new(function(pPlot) return isPlotPassablePlayer(pPlot, gCurrentPlayer) end)
		gNeedRescan = false
	end
	if (gNeedRescan) then
		gRiverManager:rescanMap()
		gNeedRescan = false
	end
	-- remember the current player for the isPlotPassablePlayer method
	gCurrentPlayer = Players[iPlayer]
	return gRiverManager
end

GameEvents.TerraformingMap.Add(function(iEvent, iLoad)
  GameEvents.TerraformingPlot.Add(OnTerraformingPlot)
end)

function OnTerraformingPlot(iEvent, iPlotX, iPlotY, iInfo, iNewValue, iOldValue, iNewExtra, iOldExtra)
	if (not gNeedRescan) then
		if (iEvent == TerraformingEventTypes.TERRAFORMINGEVENT_TERRAIN and (iNewValue == TerrainTypes.TERRAIN_COAST or iOldValue == TerrainTypes.TERRAIN_COAST)) then
		-- If a plot terrain has changed to/from coast (lake), invalidate the river manager
			gNeedRescan = true
		elseif (iEvent == TerraformingEventTypes.TERRAFORMINGEVENT_RIVER) then
		-- If a river segment changes, invalidate the river manager
			gNeedRescan = true
		end
	end
end

function OnCityConnections(iPlayer, bDirect)
	return (not bDirect)
end
GameEvents.CityConnections.Add(OnCityConnections)

function RiverCityConnection_OnCityConnected(iPlayer, iCityX, iCityY, iToCityX, iToCityY, bDirect)
	local fCity = Map.GetPlot(iCityX, iCityY):GetPlotCity()
	local tCity = Map.GetPlot(iToCityX, iToCityY):GetPlotCity()
	local pPlayer = Players[iPlayer];
	for row in GameInfo.Traits("RiverCityConnections = 1") do
		if pPlayer:HasTrait(row.ID) and ( not bDirect ) then 
			return (#(getRiverManager(iPlayer):getRiverBankRoute(iCityX, iCityY, iToCityX, iToCityY)) > 0)
		end
	end
	return false
end
GameEvents.CityConnected.Add(RiverCityConnection_OnCityConnected)
--=======================================================================================================================
--=======================================================================================================================